Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt.image
Class ConvolveOp

    java.lang.Object
      |
      +--java.awt.image.ConvolveOp

All Implemented Interfaces:
  BufferedImageOp, RasterOp

public class ConvolveOp
extends Object
implements BufferedImageOp, RasterOp

This class implements a convolution from the source to the destination. Convolution using a convolution kernel is a spatial operation that computes the output pixel from an input pixel by multiplying the kernel with the surround of the input pixel. This allows the output pixel to be affected by the immediate neighborhood in a way that can be mathematically specified with a kernel.

This class operates with BufferedImage data in which color components are premultiplied with the alpha component. If the Source BufferedImage has an alpha component, and the color components are not premultiplied with the alpha component, then the data are premultiplied before being convolved. If the Destination has color components which are not premultiplied, then alpha is divided out before storing into the Destination (if alpha is 0, the color components are set to 0). If the Destination has no alpha component, then the resulting alpha is discarded after first dividing it out of the color components.

Rasters are treated as having no alpha channel. If the above treatment of the alpha channel in BufferedImages is not desired, it may be avoided by getting the Raster of a source BufferedImage and using the filter method of this class which works with Rasters.

If a RenderingHints object is specified in the constructor, the color rendering hint and the dithering hint may be used when color conversion is required.

Note that the Source and the Destination may not be the same object.

See Also:
  `Kernel`, `RenderingHints.KEY_COLOR_RENDERING`, `RenderingHints.KEY_DITHERING`

Field Summary
`static int` | `EDGE_NO_OP` Pixels at the edge of the source image are copied to the corresponding pixels in the destination without modification.
`static int` | `EDGE_ZERO_FILL` Pixels at the edge of the destination image are set to zero.

Constructor Summary
`ConvolveOp(Kernel kernel)` Constructs a ConvolveOp given a Kernel.
`ConvolveOp(Kernel kernel, int edgeCondition, RenderingHints hints)` Constructs a ConvolveOp given a Kernel, an edge condition, and a RenderingHints object (which may be null).

Method Summary
`BufferedImage` | `createCompatibleDestImage(BufferedImage src, ColorModel destCM)` Creates a zeroed destination image with the correct size and number of bands.
`WritableRaster` | `createCompatibleDestRaster(Raster src)` Creates a zeroed destination Raster with the correct size and number of bands, given this source.
`BufferedImage` | `filter(BufferedImage src, BufferedImage dst)` Performs a convolution on BufferedImages.
`WritableRaster` | `filter(Raster src, WritableRaster dst)` Performs a convolution on Rasters.
`Rectangle2D` | `getBounds2D(BufferedImage src)` Returns the bounding box of the filtered destination image.
`Rectangle2D` | `getBounds2D(Raster src)` Returns the bounding box of the filtered destination Raster.
`int` | `getEdgeCondition()` Returns the edge condition.
`Kernel` | `getKernel()` Returns the Kernel.
`Point2D` | `getPoint2D(Point2D srcPt, Point2D dstPt)` Returns the location of the destination point given a point in the source.
`RenderingHints` | `getRenderingHints()` Returns the rendering hints for this op.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### EDGE_ZERO_FILL

    public static final int EDGE_ZERO_FILL

  Pixels at the edge of the destination image are set to zero. This is the default.

### EDGE_NO_OP

    public static final int EDGE_NO_OP

  Pixels at the edge of the source image are copied to the corresponding pixels in the destination without modification.

Constructor Detail

### ConvolveOp

    public ConvolveOp(Kernel kernel,
                      int edgeCondition,
                      RenderingHints hints)

  Constructs a ConvolveOp given a Kernel, an edge condition, and a RenderingHints object (which may be null).
  See Also:
    `Kernel`, `EDGE_NO_OP`, `EDGE_ZERO_FILL`, `RenderingHints`

### ConvolveOp

    public ConvolveOp(Kernel kernel)

  Constructs a ConvolveOp given a Kernel. The edge condition will be EDGE_ZERO_FILL.
  See Also:
    `Kernel`, `EDGE_ZERO_FILL`

Method Detail

### getEdgeCondition

    public int getEdgeCondition()

  Returns the edge condition.
  See Also:
    `EDGE_NO_OP`, `EDGE_ZERO_FILL`

### getKernel

    public final Kernel getKernel()

  Returns the Kernel.

### filter

    public final BufferedImage filter(BufferedImage src,
                                      BufferedImage dst)

  Performs a convolution on BufferedImages. Each component of the source image will be convolved (including the alpha component, if present). If the color model in the source image is not the same as that in the destination image, the pixels will be converted in the destination. If the destination image is null, a BufferedImage will be created with the source ColorModel. The IllegalArgumentException may be thrown if the source is the same as the destination.
  Specified by:
    `filter` in interface `BufferedImageOp`
  Parameters:
    `src` - the source `BufferedImage` to filter
    `dst` - the destination `BufferedImage` for the filtered `src`
  Returns:
    the filtered `BufferedImage`
  Throws:
    `NullPointerException` - if `src` is `null`
    `IllegalArgumentException` - if `src` equals `dst`
    `ImagingOpException` - if `src` cannot be filtered

### filter

    public final WritableRaster filter(Raster src,
                                       WritableRaster dst)

  Performs a convolution on Rasters. Each band of the source Raster will be convolved. The source and destination must have the same number of bands. If the destination Raster is null, a new Raster will be created. The IllegalArgumentException may be thrown if the source is the same as the destination.
  Specified by:
    `filter` in interface `RasterOp`
  Parameters:
    `src` - the source `Raster` to filter
    `dst` - the destination `WritableRaster` for the filtered `src`
  Returns:
    the filtered `WritableRaster`
  Throws:
    `NullPointerException` - if `src` is `null`
    `ImagingOpException` - if `src` and `dst` do not have the same number of bands
    `ImagingOpException` - if `src` cannot be filtered
    `IllegalArgumentException` - if `src` equals `dst`

### createCompatibleDestImage

    public BufferedImage createCompatibleDestImage(BufferedImage src,
                                                   ColorModel destCM)

  Creates a zeroed destination image with the correct size and number of bands. If destCM is null, an appropriate ColorModel will be used.
  Specified by:
    `createCompatibleDestImage` in interface `BufferedImageOp`
  Parameters:
    `src` - Source image for the filter operation.
    `destCM` - ColorModel of the destination. Can be null.

### createCompatibleDestRaster

    public WritableRaster createCompatibleDestRaster(Raster src)

  Creates a zeroed destination Raster with the correct size and number of bands, given this source.
  Specified by:
    `createCompatibleDestRaster` in interface `RasterOp`

### getBounds2D

    public final Rectangle2D getBounds2D(BufferedImage src)

  Returns the bounding box of the filtered destination image. Since this is not a geometric operation, the bounding box does not change.
  Specified by:
    `getBounds2D` in interface `BufferedImageOp`

### getBounds2D

    public final Rectangle2D getBounds2D(Raster src)

  Returns the bounding box of the filtered destination Raster. Since this is not a geometric operation, the bounding box does not change.
  Specified by:
    `getBounds2D` in interface `RasterOp`

### getPoint2D

    public final Point2D getPoint2D(Point2D srcPt,
                                    Point2D dstPt)

  Returns the location of the destination point given a point in the source. If dstPt is non-null, it will be used to hold the return value. Since this is not a geometric operation, the srcPt will equal the dstPt.
  Specified by:
    `getPoint2D` in interface `BufferedImageOp`

### getRenderingHints

    public final RenderingHints getRenderingHints()

  Returns the rendering hints for this op.
  Specified by:
    `getRenderingHints` in interface `BufferedImageOp`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.